require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/tools/indicator_measures', type: :request do
  # Tools::IndicatorMeasure. As you add validations to Tools::IndicatorMeasure, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) { FactoryBot.attributes_for(:indicator_measure, indicator_id: indicator.id) }
  let(:invalid_attributes) { FactoryBot.attributes_for(:indicator_measure, indicator_id: nil) }

  let(:rca) { FactoryBot.create(:rca, methodology: methodology) }
  let(:methodology) { FactoryBot.create(:methodology, :with_step_1) }
  let(:user) { FactoryBot.create(:user) }
  let(:indicator) { FactoryBot.create(:indicator, rca_id: rca.id) }

  context 'From logged user' do
    before :each do
      user.set_session(:active_step_tool, methodology.steps.first.step_tools.first.id)
      user.save!

      sign_in user
    end

    describe 'GET /new' do
      context 'without rca defined' do
        it 'renders a redirection response' do
          get new_tools_indicator_measure_url, params: {}, xhr: true
          expect(response).to have_http_status(:redirect)
          expect(response).to redirect_to(rcas_path)
        end
      end

      context 'without indicator defined' do
        it 'renders a redirection response' do
          get new_tools_indicator_measure_url, params: { rca: rca.id }, xhr: true
          expect(response).to have_http_status(:redirect)
          expect(response).to redirect_to(edit_rca_path(rca))
        end
      end

      context 'with indicator and attributes defined' do
        it 'renders a successful response' do
          get new_tools_indicator_measure_url, params: { rca: rca.id, tools_indicator_measure: valid_attributes }, xhr: true
          expect(response).to be_successful
        end
      end
    end

    describe 'GET /edit' do
      it 'render a successful response' do
        tools_indicator_measure = Tools::IndicatorMeasure.create! valid_attributes
        get edit_tools_indicator_measure_url(tools_indicator_measure), xhr: true
        expect(response).to be_successful
      end
    end

    describe 'POST /create' do
      context 'with valid rca & parameters' do
        it 'creates a new Tools::IndicatorMeasure' do
          expect {
            post tools_indicator_measures_url, params: { rca: rca.id, tools_indicator_measure: valid_attributes }
          }.to change(Tools::IndicatorMeasure, :count).by(1)
        end

        it 'redirects to the tool indicators index' do
          post tools_indicator_measures_url, params: { rca: rca.id, tools_indicator_measure: valid_attributes }
          expect(response).to redirect_to(tools_indicators_url(rca: rca))
        end
      end

      context 'without valid rca' do
        it 'creates a new Tools::IndicatorMeasure' do
          expect {
            post tools_indicator_measures_url, params: { tools_indicator_measure: valid_attributes }
          }.to change(Tools::IndicatorMeasure, :count).by(0)
        end

        it 'redirects to the tool indicators index' do
          post tools_indicator_measures_url, params: { tools_indicator_measure: valid_attributes }
          expect(response).to redirect_to(rcas_path)
        end
      end

      context 'with invalid parameters' do
        it 'does not create a new Tools::IndicatorMeasure' do
          expect {
            post tools_indicator_measures_url, params: { rca: rca.id, tools_indicator_measure: invalid_attributes }, xhr: true
          }.to change(Tools::IndicatorMeasure, :count).by(0)
        end

        it 'renders a successful response (i.e. to display the new template)' do
          post tools_indicator_measures_url, params: { rca: rca.id, tools_indicator_measure: invalid_attributes }, xhr: true
          expect(response).to be_successful
        end
      end
    end

    describe 'PATCH /update' do
      context 'with valid parameters' do
        let(:new_attributes) { {name: 'New Name'} }

        it 'updates the requested tools_indicator_measure' do
          tools_indicator_measure = Tools::IndicatorMeasure.create! valid_attributes
          patch tools_indicator_measure_url(tools_indicator_measure), params: { tools_indicator_measure: new_attributes }
          tools_indicator_measure.reload

          expect(tools_indicator_measure.name).to eq 'New Name'
        end

        it 'redirects to the tool indicators index' do
          tools_indicator_measure = Tools::IndicatorMeasure.create! valid_attributes
          patch tools_indicator_measure_url(tools_indicator_measure), params: { tools_indicator_measure: new_attributes }
          tools_indicator_measure.reload
          expect(response).to redirect_to(tools_indicators_url(rca: rca))
        end
      end

      context 'with invalid parameters' do
        it 'renders a successful response (i.e. to display the edit template)' do
          tools_indicator_measure = Tools::IndicatorMeasure.create! valid_attributes
          patch tools_indicator_measure_url(tools_indicator_measure), params: { tools_indicator_measure: invalid_attributes }, xhr: true
          expect(response).to be_successful
        end
      end
    end

    describe 'DELETE /destroy' do
      it 'destroys the requested tools_indicator_measure' do
        tools_indicator_measure = Tools::IndicatorMeasure.create! valid_attributes
        expect {
          delete tools_indicator_measure_url(tools_indicator_measure)
        }.to change(Tools::IndicatorMeasure, :count).by(-1)
      end

      it 'redirects to the tool indicators index' do
        tools_indicator_measure = Tools::IndicatorMeasure.create! valid_attributes
        delete tools_indicator_measure_url(tools_indicator_measure)
        expect(response).to redirect_to(tools_indicators_url(rca: rca))
      end
    end
  end
end
